package test;
import static org.junit.Assert.*;
import java.util.HashSet;
import java.util.Set;
import org.junit.Before;
import org.junit.Test;
import card.Card;
import card.Zako;
import player.CardCollection;
public class CardCollectionTest  {
	private CardCollection c;
	@Before
	public void setUp() throws Exception {
		c = new CardCollection();
		for(Card card : Zako.getList()){
			c.add(card);
		}
	}
	@Test
	public void testToString() {
		CardCollection c = new CardCollection();
		Card[] card = Zako.getList().toArray(new Card[0]);
		c.add(card[0]);
		c.add(card[1]);
		c.add(card[1]);
		assertEquals("Aka: 1\nAo: 2\n",c.toString());
	}
	@Test
	public void testContains(){
		for(Card card : Zako.getList()){
			assertTrue(c.contains(card));
		}
	}
	@Test
	public void testCompletes2(){
		Set<Integer> watch = new HashSet<Integer>();
		CardCollection c = new CardCollection();
		assertTrue(c.completes(watch));
		for(Card card : Zako.getList()){
			c.add(card);
			assertTrue(c.completes(watch));
		}
	}
	@Test
	public void testCompletes(){
		Set<Integer> watch = new HashSet<Integer>();
		watch.add(0);
		watch.add(1);
		watch.add(2);
		CardCollection c = new CardCollection();
		Card[] card = Zako.getList().toArray(new Card[0]);
		assertFalse(c.completes(watch));
		c.add(card[0]);
		assertFalse(c.completes(watch));
		c.add(card[1]);
		assertFalse(c.completes(watch));
		c.add(card[1]);
		assertFalse(c.completes(watch));
		c.add(card[2]);
		assertTrue(c.completes(watch));
	}
}
