package test;
import java.util.Collection;
import card.Card;
public class CommonCardTest {
	protected interface TestIntMethod{
		int perform(Card e);
	}
	protected static int[] toIntArray(Collection<? extends Card> arg, TestIntMethod b){
		int[] result = new int[arg.size()];
		int i=0;
		for(Card e : arg){
			result[i++]=b.perform(e);
		}
		return result;
	}
	protected class Id implements TestIntMethod {
		@Override
		public int perform(Card e) {
			return e.id();
		}
	}
	protected class Rate implements TestIntMethod {
		@Override
		public int perform(Card e) {
			return e.rate();
		}
	}
	protected interface TestObjectMethod<F> {
		F perform(Card e);
	}
	protected static <F> F[] toObjectArray(Collection<? extends Card> arg, TestObjectMethod<F> b){
		@SuppressWarnings("unchecked")
		F[] result = (F[]) new Object[arg.size()];
		int i=0;
		for(Card e : arg){
			result[i++]=b.perform(e);
		}
		return result;
	}
	protected class ToString implements TestObjectMethod<String>{
		@Override
		public String perform(Card e) {
			return e.toString();
		}
	}
	protected class Name implements TestObjectMethod<String>{
		@Override
		public String perform(Card e) {
			return e.name();
		}
	}
}