package test;
import gacha.AbstractDeck;
import java.util.Collection;
import java.util.Map.Entry;
import card.Card;
public class CommonDeckTest {
	protected interface TestDoubleMethod<E> {
		double perform(E e);
	}
	protected static <E> double[] toDoubleArray(Collection<E> arg, TestDoubleMethod<E> b){
		double[] result = new double[arg.size()];
		int i=0;
		for(E e : arg){
			result[i++]=b.perform(e);
		}
		return result;
	}	
	protected class GetKey implements TestDoubleMethod<Entry<Double,Card>> {
		@Override
		public double perform(Entry<Double, Card> e) {
			return e.getKey();
		}
	}
	protected class GetCardRate implements TestDoubleMethod<Card> {
		private AbstractDeck deck;
		public GetCardRate(AbstractDeck deck) {
			super();
			this.deck = deck;
		}
		@Override
		public double perform(Card card) {
			return deck.getCardRate(card);
		}
	}
}