package test;
import static org.junit.Assert.*;
import java.util.List;
import gacha.Deck2;
import org.junit.Before;
import org.junit.Test;
import card.Card;
public class Deck2Test extends CommonDeckTest {
	private Deck2 deck;
	private List<Card> list;
	@Before
	public void setUp() throws Exception {
		deck=new Deck2();
		list = Deck2.getList();
	}
	@Test
	public void testTotal() {
		assertEquals(3.03,deck.total(),Constant.err);
	}
	@Test
	public void testGetCardRate() {
		double[] rate = new double[]{1.0,1.0,1.0,0.01,0.01,0.01};
		assertArrayEquals(rate, toDoubleArray(list,new GetCardRate(deck)), Constant.err);
	}
	@Test
	public void testCalcMap() {
		double[] dist = new double[]{0.0, 0.33003, 0.660067, 0.99010, 0.99340, 0.99670};
		assertArrayEquals(dist, toDoubleArray(deck.calcMap().entrySet(),new GetKey()), Constant.err);
	}
	@Test
	public void testList() {
		assertEquals("[Aka, Ao, Kuro, RareAka, RareAo, RareKuro]",list.toString());
	}
	@Test
	public void testToString() {
		assertEquals("[Aka, Ao, Kuro, RareAka, RareAo, RareKuro]",deck.toString());
	}
}
