package test;
import static org.junit.Assert.*;
import java.util.Iterator;
import java.util.List;
import java.util.Map.Entry;
import gacha.Deck3;
import org.junit.Before;
import org.junit.Test;
import card.Card;
import player.CardCollection;
public class Deck3Test extends CommonDeckTest {
	private CardCollection cc;
	private Deck3 deck;
	private List<Card> list;
	@Before
	public void setUp() throws Exception {
		cc = new CardCollection();
		deck = new Deck3(cc);
		list = Deck3.getList(cc);
	}
	@Test
	public void testTotal() {
		assertEquals(3.03,deck.total(),Constant.err);
	}
	@Test
	public void testGetCardRate0() {
		double[] rate = new double[]{1.0,1.0,1.0,0.01,0.01,0.01};
		assertArrayEquals(rate, toDoubleArray(list,new GetCardRate(deck)), Constant.err);
	}
	@Test
	public void testGetCardRate1() {
		double[] rate = new double[]{1.0,1.0,1.0,0.01,0.001,0.001};
		cc.add(list.get(3));
		assertArrayEquals(rate, toDoubleArray(list,new GetCardRate(deck)), Constant.err);
	}
	@Test
	public void testGetCardRate2() {
		double[] rate = new double[]{1.0,1.0,1.0,0.01,0.001,0.001};
		cc.add(list.get(3));
		cc.add(list.get(3));
		assertArrayEquals(rate, toDoubleArray(list,new GetCardRate(deck)), Constant.err);
	}
	@Test
	public void testGetCardRate3() {
		double[] rate = new double[]{1.0,1.0,1.0,0.01,0.01,0.0001};
		cc.add(list.get(3));
		cc.add(list.get(3));
		cc.add(list.get(4));
		assertArrayEquals(rate, toDoubleArray(list,new GetCardRate(deck)), Constant.err);
	}
	@Test
	public void testCalcMap0() {
		double[] dist = new double[]{0.0, 0.33003, 0.66007, 0.99010, 0.99340, 0.99670};
		assertArrayEquals(dist, toDoubleArray(deck.calcMap().entrySet(),new GetKey()), Constant.err);
	}
	@Test
	public void testCalcMap1() {
		double[] dist = new double[]{0.0, 0.332005, 0.66401, 0.99602, 0.99934, 0.99967};
		cc.add(list.get(3));
		assertArrayEquals(dist, toDoubleArray(deck.calcMap().entrySet(),new GetKey()), Constant.err);
	}
	@Test
	public void testCalcMap2() {
		double[] dist = new double[]{0.0, 0.332005, 0.66401, 0.99602, 0.99934, 0.99967};
		cc.add(list.get(3));
		cc.add(list.get(3));
		assertArrayEquals(dist, toDoubleArray(deck.calcMap().entrySet(),new GetKey()), Constant.err);
		Iterator<Entry<Double, Card>> iterator = deck.calcMap().entrySet().iterator();
		int i=0;
		while(iterator.hasNext()){
			Entry<Double, Card>	 e = iterator.next();
			assertEquals(dist[i++],e.getKey(),Constant.err);
		}
	}
	@Test
	public void testCalcMap3() {
		double[] prob = new double[]{0.0, 0.33111, 0.66223, 0.99334, 0.99666, 0.99997};
		cc.add(list.get(3));
		cc.add(list.get(3));
		cc.add(list.get(4));
		assertArrayEquals(prob, toDoubleArray(deck.calcMap().entrySet(),new GetKey()), Constant.err);
	}
	@Test
	public void testList() {
		assertEquals("[Aka, Ao, Kuro, SuperRareAka, SuperRareAo, SuperRareKuro]",list.toString());
	}
	@Test
	public void testToString() {
		assertEquals("[Aka, Ao, Kuro, SuperRareAka, SuperRareAo, SuperRareKuro]",deck.toString());
	}
}
