package test;
import static org.junit.Assert.*;
import java.util.List;
import kotae.SuperRare;
import org.junit.Before;
import org.junit.Test;
import player.CardCollection;
import card.Card;
public class SuperRareTest extends CommonCardTest {
	private List<SuperRare> list;
	private CardCollection cc;
	@Before
	public void setup(){
		cc = new CardCollection();
		list=  SuperRare.getList(cc);
	}
	@Test
	public void testClass(){
		assertTrue(list.get(0) instanceof SuperRare);
		assertTrue(list.get(1) instanceof SuperRare);
		assertTrue(list.get(2) instanceof SuperRare);
	}
	@Test
	public void testMultiplayer(){
		CardCollection cc2 = new CardCollection();
		List<SuperRare> list2 = SuperRare.getList(cc2);
		assertArrayEquals(new int[]{100,100,100}, toIntArray(list,new Rate()));
		assertArrayEquals(new int[]{100,100,100}, toIntArray(list2,new Rate()));
		cc.add(list.get(0));
		assertArrayEquals(new int[]{100,1000,1000}, toIntArray(list,new Rate()));
		assertArrayEquals(new int[]{100,100,100}, toIntArray(list2,new Rate()));
		cc2.add(list2.get(1));
		assertArrayEquals(new int[]{100,1000,1000}, toIntArray(list,new Rate()));
		assertArrayEquals(new int[]{1000,100,1000}, toIntArray(list2,new Rate()));
		cc2.add(list2.get(2));
		assertArrayEquals(new int[]{100,1000,1000}, toIntArray(list,new Rate()));
		assertArrayEquals(new int[]{10000,100,100}, toIntArray(list2,new Rate()));
		cc2.add(list2.get(0));
		assertArrayEquals(new int[]{100,1000,1000}, toIntArray(list,new Rate()));
		assertArrayEquals(new int[]{100,100,100}, toIntArray(list2,new Rate()));
	}
	@Test
	public void testRate0() {
		int[] exp = {100,100,100};
		assertArrayEquals(exp, toIntArray(list,new Rate()));
	}
	@Test
	public void testRate1() {
		int[] exp = {1000,1000,100};
		cc.add(list.get(2));
		assertArrayEquals(exp, toIntArray(list,new Rate()));
	}
	@Test
	public void testRate2() {
		int[] exp = {1000,1000,100};
		cc.add(list.get(2));
		cc.add(list.get(2));
		assertArrayEquals(exp, toIntArray(list,new Rate()));
	}
	@Test
	public void testRate3() {
		int[] exp = {10000,100,100};
		cc.add(list.get(2));
		cc.add(list.get(2));
		cc.add(list.get(1));
		assertArrayEquals(exp, toIntArray(list,new Rate()));
	}
	@Test
	public void testToString(){
		String[] exp = {"SuperRareAka","SuperRareAo","SuperRareKuro"};
		assertArrayEquals(exp, toObjectArray(list,new ToString()));
	}
	@Test
	public void testName(){
		String[] exp = {"SuperRareAka","SuperRareAo","SuperRareKuro"};
		assertArrayEquals(exp, toObjectArray(list,new Name()));
	}
	@Test
	public void testOrder() {
		int[] exp = {20,21,22};
		assertArrayEquals(exp, toIntArray(list,new Id()));
	}
	@Test
	public void testCompareTo() {
		int[] exp = {0,-1,-1,1,0,-1,1,1,0};
		int i=0;
		for(Card c1 : list){
			for(Card c2 :list){
				int result = c1.compareTo(c2);
				String message = c1+"compareTo"+c2;
				switch(exp[i++]){
				case -1: assertTrue(message,result<0);
				break;
				case 0: assertEquals(message,0,result);
				break;
				case 1: assertTrue(message,result>0);
				break;
				}
			}
		}
	}
}
